SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicols 5/31/2013 19:00'!
carritoConUnLibro
     | book1 catalog |
	book1 := '3514564564674'.
	catalog := self catalogo.
	
	^ (Cart newCartWithCatalog: catalog) add: book1! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 21:57'!
carritoConVariosLibros
     | book1 catalog book2 book3 carritoNuevo|

	book1 := '3514564564674'.
	book2 := '6464564564564'.
	book3:= '35145645646748'.	
	catalog := self catalogo.
	carritoNuevo := Cart newCartWithCatalog: catalog.
	
	carritoNuevo add: book1.
	carritoNuevo add: book2 withQuantity: 5.
	carritoNuevo add: book3 withQuantity: 8.
		
	^ carritoNuevo ! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 19:35'!
carritoDePepe 

  ^self interface createCartFor: 'pepe' usingPassword: '1234'
	! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:23'!
carritoVacio
	
		^ Cart newCartWithCatalog: self catalogo! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoEzequielNicols 6/8/2013 20:27'!
cashier 

	^Cashier newWith: (TusLibrosTest new) okMerchantProcessor.! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicols 5/31/2013 19:07'!
catalogo
	| book1 book2 catalog book3 |
	
	book1 := '3514564564674'.
	book2 := '6464564564564'.
	book3:= '35145645646748'.	
	
	catalog := Dictionary new.
	catalog at: book1 put: 2.
	catalog at: book2 put: 25.
	catalog at: book3 put: 27.
	
	^ catalog! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 22:26'!
editorial
	^ Publisher newWith: self catalogo! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:48'!
failedMerchantProcessor
	^ PluggableMerchantProcessor newWith: [ Error signal  ]! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 22:26'!
interface

	^ TusLibrosInterface newWithSecurityGuard: (self securityGuard ) andClock: (self now) andCashier: (self cashier ) andPublisher: self editorial! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 17:00'!
isbnInCatalog
	^ '3514564564674'.! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoEzequielNicols 6/7/2013 22:25'!
now
	^ Clock newWithTimeStamp: TimeStamp now! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 23:37'!
okMerchantProcessor
	^ PluggableMerchantProcessor newWith: [ 'OK' ]! !

!TusLibrosTest methodsFor: 'security' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:23'!
securityGuard
	
	^SecurityGuard newWith: self userRegistry.  ! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 20:00'!
tarjetaNoVencida
	
	^ CreditCard newWithNumber: '32442342423' andOwner: 'pepe' andExpirationDate: (Date today + 60)! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:54'!
tarjetaVencida
	
	^CreditCard newWithNumber: '32442342423' andOwner: 'pepe' andExpirationDate: Date yesterday! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:23'!
test01AllCartsAreCreatedEmpty
	"Todo carrito se crea vaco"

	self assert: self carritoVacio isEmpty.! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:23'!
test02AfterAddingTheFirstBookCartShouldNotBeEmpty
	"Luego de agregarle libros, el carrito no est vaco"

	self deny: (self carritoVacio add: '6464564564564' withQuantity: 1) isEmpty.! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:23'!
test03AfterAddingMoreBooksCartShouldStillNotBeEmpty
	"Luego de agregarle libros, el carrito no est vaco"

	| aBook aCartWithBooks|
	
	aBook:= '3514564564674'.
	
	aCartWithBooks:=  self carritoVacio add: aBook withQuantity: 1.
	
	self deny: (aCartWithBooks add: aBook withQuantity: 1) isEmpty.
	! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:23'!
test04BooksAddedShouldAppearWithTheirQuantities
	
	| aBook aCartWithBooks|
	
	aBook:= '35145645646748'.
	
	aCartWithBooks:=  self carritoVacio add: aBook withQuantity: 1.
	aCartWithBooks add: aBook withQuantity: 1.
		
	self assert: (aCartWithBooks hasItem: aBook  withQuantity: 2)! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:23'!
test05CartShouldOnlyHaveTheBooksThatWereAdded
	
	| book1 book2 aCartWithBooks|
	
	book1:= '35145645646748'.
	book2:= '6464564564564'.
	
	aCartWithBooks:=  self carritoVacio add: book1 withQuantity: 1.
	aCartWithBooks add: book2 withQuantity: 1.
	
	self assert: (aCartWithBooks hasItem: book1 withQuantity: 1).
	self assert: (aCartWithBooks hasItem: book2 withQuantity: 1).	
	self assert: (aCartWithBooks size = 2)
! !

!TusLibrosTest methodsFor: '1) Cart' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:23'!
test06CannotAddBooksNotInTheCatalog
	
	| book1 aCartWithBooks|
	
	book1:= '35145645646747'.
	

	
	self should: [ self carritoVacio add: book1 withQuantity: 1] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = 'El libro no pertenece al catlogo']  ! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 23:02'!
test07CheckoutOfCartShouldReturnTicketWithSameItemsQuantitiesandAccordingPrices
	"El checkout devuelve un ticket con los mismos items del carrito, sus cantidades y el precio de cada item "

	|cart aCashier ticketItems cartItems ticket |
	
	
	aCashier:= Cashier newWith: self okMerchantProcessor.
	cart := self carritoConVariosLibros.
	ticket := aCashier checkOut: cart payingWith: self tarjetaNoVencida.
	ticketItems := ticket items.
	cartItems := cart items.
	
	"self assert: (ticket transactionResult = 'OK')."
	self assert: (ticketItems size = cartItems size). 
	ticketItems do: [:aTicketItem | | expectedPrice |
		expectedPrice := (cart itemPrice: aTicketItem itemName) * (cart itemQuantity: aTicketItem itemName) .  
		
		self assert: ((cart hasItem: aTicketItem itemName withQuantity: aTicketItem quantity) and: [aTicketItem price =  expectedPrice ])] ! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 23:03'!
test08CheckoutOfCartWithSingleElementShouldReturnSinglePrice

	|cart aCashier expectedTotal |
	
	
	aCashier:= Cashier newWith: self okMerchantProcessor.
	cart := self carritoConUnLibro.
	expectedTotal :=  aCashier calculateTotal: cart.
	
	self assert: ((aCashier checkOut: cart payingWith: self tarjetaNoVencida) total = expectedTotal) ! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 22:29'!
testAddToCartNotFoundShouldReturnAnError

	
	| interface cartId |
	
	interface := self interface.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	
	self should: [interface addToCart: 0 aBookISBN: '3514564564673'  withQuantity: 1]
	raise: Error
	withExceptionDo: [:anError | self assert: anError messageText equals: 'CartId Not Found' ]
	
	
	
	! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 22:30'!
testAddingAnISBNtoAnActiveCartShouldUpdateTheCart

	| interface cartId cart |
		
	interface := self interface.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	
	cart := (interface getCartWithId: cartId).
	
	self assert: cart isEmpty.
	
	interface addToCart: cartId aBookISBN: '3514564564674' withQuantity: 1.
	
	self assert: ((cart getQuantityOf: '3514564564674' )= 1)
	
	
	
	! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/10/2013 00:20'!
testAddingAnISBNtoAnExpiredCartShouldReturnAnError
	| interface cartId clock |
	


	interface := self interface.
	clock := interface clock.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	
	clock plusMinutes: 31.
	
	self	should: [ interface addToCart: cartId aBookISBN: (self isbnInCatalog) withQuantity: 1 ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText equals: 'Session has expired' ]! !

!TusLibrosTest methodsFor: 'session' stamp: 'EmilianoEzequielNicols 6/9/2013 17:38'!
testAfter10MinutesSessionShouldStillBeActive

	| session clock |

	clock := self now.
	
	session := Session newWithClientId: '1234' andCart: self carritoVacio andClock: clock.
	
	clock plusMinutes: 10.
	
	self assert: session hasExpired not .
! !

!TusLibrosTest methodsFor: 'session' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 18:55'!
testAfter30MinutesSessionShouldExpire

	| session clock |

	clock := self now.
	
	session := Session newWithClientId: '1234' andCart: self carritoVacio andClock: clock.
	
	clock plusMinutes: 30.
	
	self assert: session hasExpired.
! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/10/2013 00:20'!
testCheckOutOfAnExpiredCartShouldReturnAnError
	
	| interface cartId clock aCreditCard |
	
	
	aCreditCard := self tarjetaNoVencida.
	interface := self interface.
	clock := interface clock.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	
	clock plusMinutes: 31.
	
	self	should: [ interface checkOut: cartId  payingWith: aCreditCard ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText equals:  'Session has expired' ]! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:30'!
testCheckoutOfEmptyCartShouldRaiseAnError

	|emptyCart aCashier|

	emptyCart := self carritoVacio .
      aCashier := Cashier newWith: self okMerchantProcessor. 

 	self should: [aCashier checkOut: emptyCart payingWith: self tarjetaNoVencida ] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = Cashier cantCheckoutEmptyCartMessage]  ! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:31'!
testCheckoutWithExpiredCardDoesNotCallTheMerchantProcessor

	|cashier merchantProcessor|
	
	merchantProcessor := PluggableMerchantProcessor new initializeWith: [ self fail: 'MerchantProcessor should not be called using expired card.' ].
	cashier := Cashier newWith: merchantProcessor.
	
	self should: [cashier checkOut: self carritoConUnLibro payingWith: self tarjetaVencida]
	raise: Error
	withExceptionDo: [:anError | self assert: anError messageText equals: 'EXPIRED_CARD' ]! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 19:34'!
testCheckoutWithStolenCardShouldRejectTransaction

	|cashier merchantProcessor |
	
	merchantProcessor := PluggableMerchantProcessor new initializeWith: [ Error signal: 'Card was stolen.'].
	cashier := Cashier newWith: merchantProcessor.
	
	self should: [cashier checkOut: self carritoConUnLibro payingWith: self tarjetaNoVencida ]
	raise: Error
	withExceptionDo: [:anError | self assert: anError messageText equals: 'Card was stolen.' ]! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 23:54'!
testCorrectCheckOutOfACartShouldAddTicketToCustomerSalesBook
	
	| interface cartId ticket salesUpToNow publisher |
	
	
	interface := self interface.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	salesUpToNow := interface listPurchasesOf: 'pepe'.
	interface addToCart: cartId aBookISBN: self isbnInCatalog  withQuantity: 5.
	ticket := interface checkOut: cartId  payingWith: self tarjetaNoVencida.
	
	
	salesUpToNow add: ticket.
	
	publisher := interface getPublisher.
	
	self assert: ( (publisher getSalesFor: 'pepe') =  salesUpToNow )! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 22:47'!
testCreateCartWithValidCredentialsShouldReturnANewCart
	
	| interface cartId cart session |

	
	interface := self interface.
	
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	
	session := interface getSessionWithId: cartId.
	self deny: session hasExpired.
	
	cart := interface getCartWithId: cartId.
	self assert: cart isEmpty.
	
	
! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:23'!
testCreatingACreditCardWithDataOKShouldReturnTheCard

	| creditCard expectedNumber expectedOwner expectedExpirationDate |
	
	expectedNumber := '1234'.
	expectedOwner := 'Homero Simpson'.
	expectedExpirationDate := Date tomorrow.
	
	creditCard := CreditCard newWithNumber: expectedNumber andOwner: expectedOwner andExpirationDate: expectedExpirationDate.
	
	self assert: creditCard number equals: expectedNumber.
	self assert: creditCard owner equals: expectedOwner.
	self assert: creditCard expirationDate equals: expectedExpirationDate.! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:23'!
testCreatingACreditCardWithEmptyNumberShouldRaiseAnError

	 self should: [CreditCard newWithNumber: '' andOwner: 'Homero Simpson' andExpirationDate: Date tomorrow] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = 'Credit card number cannot be empty.'] ! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:23'!
testCreatingACreditCardWithEmptyOwnerNameShouldRaiseAnError

	 self should: [CreditCard newWithNumber: '1234' andOwner: '' andExpirationDate: Date tomorrow] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = 'Credit card owner cannot be empty.'] ! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:23'!
testCreatingACreditCardWithOwnerNameLengthGreaterThan30ShouldRaiseAnError

	 self should: [CreditCard newWithNumber: '1234' andOwner: '123456789_123456789_123456789_1' andExpirationDate: Date tomorrow] 
		raise: Error 
		withExceptionDo: [ :anError |  self assert: anError messageText = 'Credit card owner cannot be greater than 30 characters long.'] ! !

!TusLibrosTest methodsFor: 'session' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 18:38'!
testCreatingASessionShouldMakeItActive

	| session clock |

	clock := self now.
	
	session := Session newWithClientId: '1234' andCart: self carritoVacio andClock: clock.
	
	self assert: session hasExpired not.
! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/10/2013 00:01'!
testFailedCheckOutOfACartShouldNotAddTicketToCustomerSalesBook
	
	| interface cartId ticket salesUpToNow publisher |
		
	interface := self interface.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	interface addToCart: cartId aBookISBN: self isbnInCatalog  withQuantity: 5.
	salesUpToNow := interface listPurchasesOf: 'pepe'.

	ticket := interface checkOut: cartId  payingWith: self tarjetaVencida.
	
	
	publisher := interface getPublisher.
	
	self assert: ( (publisher getSalesFor: 'pepe') =  salesUpToNow )! !

!TusLibrosTest methodsFor: 'session' stamp: 'EmilianoEzequielNicols 6/9/2013 17:42'!
testKeepingActiveASessionShouldUpdateItsLastAccessTime

	| clock session expectedTimestamp |

	"Setup"
	clock := self now.
	session := Session newWithClientId: '1234' andCart: self carritoVacio andClock: clock.
	clock plusMinutes: 1.
	expectedTimestamp := clock timeStamp.
 	self deny: session lastAccessTime = expectedTimestamp.
	
	"Exercise"
	session keepActive.
	
	"Verify"
	self assert: session lastAccessTime equals: expectedTimestamp.
! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 22:48'!
testListAnActiveCartShouldReturnTheItemsCart

	| interface cartId cart |
	
	interface := self interface.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	
	interface addToCart: cartId  aBookISBN: self isbnInCatalog  withQuantity: 1. 
	interface addToCart: cartId  aBookISBN: self isbnInCatalog  withQuantity: 1. 
	interface addToCart: cartId  aBookISBN: self isbnInCatalog  withQuantity: 1. 
	
	cart := interface getCartWithId: cartId.
	
	self assert: (interface listCart: cartId) = cart items.
	
	! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/10/2013 00:21'!
testListAnExpiredCartShouldReturnAnError

	| interface cartId clock |
	

	interface := self interface.
	clock := interface clock.
		
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	interface addToCart: cartId aBookISBN: self isbnInCatalog withQuantity: 1.
	
	clock plusMinutes: 31.
	
	self	should: [ interface listCart: cartId ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText equals: 'Session has expired' ]
	
	
	! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 22:56'!
testListCartNotFoundShouldReturnAnError

	| interface cartId |
	
	interface := self interface.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	
	self should: [interface listCart: 0]
	raise: Error
	withExceptionDo: [:anError | self assert: anError messageText equals: 'CartId Not Found' ]
	
	
	
	! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoEzequielNicols 6/9/2013 13:49'!
testPassingAValidCustomerIDShouldReturnPurchases

	| interface cartId session clientId purchases |

	"Setup"
	interface := self interface.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	session := interface getSessionWithId: cartId.
	clientId := session clientId.
	
	interface addToCart: cartId aBookISBN: self isbnInCatalog withQuantity: 1.
	interface checkOut: cartId payingWith: self tarjetaNoVencida.

	"Exercise"	
	purchases := interface listPurchasesOf: clientId.

	"Verify"
	self assert: purchases isEmpty not.! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoEzequielNicols 6/9/2013 13:56'!
testPassingAnIvalidCustomerIDShouldReturnAnError

	| interface cartId session |

	"Setup"
	interface := self interface.
	cartId := interface createCartFor: 'pepe' usingPassword: '1234'.
	session := interface getSessionWithId: cartId.
	
	interface addToCart: cartId aBookISBN: self isbnInCatalog withQuantity: 1.
	interface checkOut: cartId payingWith: self tarjetaNoVencida.

	self should: [interface listPurchasesOf: 'user_not_found']
	raise: Error 
	withExceptionDo: [ :anError | self assert: anError messageText equals: 'Invalid User']

	! !

!TusLibrosTest methodsFor: 'security' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:14'!
testSuccessfulUserAuthenticationShouldReturnAToken
	| token |

	token := self securityGuard validate: 'pepe' with: '1234'.

	self assert: token > 0.! !

!TusLibrosTest methodsFor: 'security' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:19'!
testTryingToAuthenticateInvalidUserNameShouldRaiseError

	self should: [self securityGuard validate: 'not_a_user' with: '1234'] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = 'Invalid User or Password.' ]
! !

!TusLibrosTest methodsFor: 'security' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:20'!
testTryingToAuthenticateUserWithInvalidPasswordShouldRaiseError

	self should: [self securityGuard validate: 'pepe' with: 'wrong_password'] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = 'Invalid User or Password.' ]! !

!TusLibrosTest methodsFor: 'interface' stamp: 'EmilianoEzequielNicols 6/9/2013 14:12'!
testTryingToListPurchasesOfAnInvalidUserShouldRaiseAnError

	
	self should: [self interface listPurchasesOf: 'user_not_found'] 
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText equals: 'Invalid User'].! !

!TusLibrosTest methodsFor: 'security' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:23'!
userRegistry
	
	|userRegistry |
	
	userRegistry := Dictionary  new.
	userRegistry at:'pepe' put:'1234'.
	^userRegistry 
	! !

Object subclass: #Cart
	instanceVariableNames: 'items catalogo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'instance-creation' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:13'!
newCartWithCatalog: aCatalog
	^ self new emptyCartWithCatalog: aCatalog! !

!Cart methodsFor: 'adding' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 21:58'!
add: anISBN 
	
	^self add: anISBN withQuantity: 1! !

!Cart methodsFor: 'adding' stamp: 'EmilianoMenendezEzequielNicols 5/31/2013 19:03'!
add: anISBN withQuantity: aQuantity 
	
	
	(catalogo includesKey: anISBN ) ifFalse:[^ Error signal: 'El libro no pertenece al catlogo' ].
	items add: anISBN withOccurrences: aQuantity ! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:01'!
catalog

	^catalogo! !

!Cart methodsFor: 'Initializing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:58'!
emptyCartWithCatalog: aCatalog
	
	items := Bag new.
	catalogo := aCatalog.! !

!Cart methodsFor: 'testing' stamp: 'EmilianoEzequielNicols 6/7/2013 21:24'!
getQuantityOf: anItem 

	^items occurrencesOf: anItem  ! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:54'!
hasItem: anISBN withQuantity: aQuantity

	^(items occurrencesOf: anISBN) = aQuantity  ! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/27/2013 21:46'!
isEmpty

	^items isEmpty! !

!Cart methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 6/1/2013 15:22'!
itemPrice: anItem 
	
	^catalogo at: anItem! !

!Cart methodsFor: 'accessing' stamp: 'EmilianoEzequielNicols 6/1/2013 16:07'!
itemQuantity: anItem  
	
	^items occurrencesOf: anItem! !

!Cart methodsFor: 'testing' stamp: 'EmilianoEzequielNicols 6/1/2013 16:25'!
items

	^items ! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 19:32'!
size

	^items size! !

Object subclass: #Cashier
	instanceVariableNames: 'merchantProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 20:42'!
cantCheckoutEmptyCartMessage
	^ 'Cant checkout an empty cart'! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/3/2013 20:20'!
newWith: aMerchantProcessor
	
	
	^ self new initializeWith: aMerchantProcessor.  ! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/2/2013 17:38'!
calculateTotal: aCart 
	
	|cartItems temporaryTotal|
	
	cartItems := aCart items.
	temporaryTotal := 0.
	
	cartItems do: [ :anItem | temporaryTotal := temporaryTotal + (( aCart itemQuantity: anItem) * (aCart itemPrice: anItem))].
	
	^temporaryTotal.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 17:12'!
checkOut: aCart payingWith: aCreditCard
	| ticket aTotal|
	
	aCart isEmpty
		ifTrue: [ ^ Error signal: self class cantCheckoutEmptyCartMessage ].
	(aCreditCard isExpired: Date today)
		ifTrue: [ ^ Error signal: 'EXPIRED_CARD' ].

	aTotal := self calculateTotal: aCart.
	
	merchantProcessor debit: aTotal fromCard: aCreditCard.
	
	ticket := Ticket newFrom: aCart withTotal: aTotal andTransactionResult: 'OK'.
	

	^ ticket! !

!Cashier methodsFor: 'initializing' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 17:11'!
initializeWith: aMerchantProcessorStub 
	
	merchantProcessor := aMerchantProcessorStub! !

Object subclass: #Clock
	instanceVariableNames: 'timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Clock class methodsFor: 'as yet unclassified' stamp: 'EmilianoEzequielNicols 6/7/2013 19:27'!
newWithTimeStamp: aTimestamp 

	^self new initializeWithTimestamp: aTimestamp.! !

!Clock methodsFor: 'initializing' stamp: 'EmilianoEzequielNicols 6/7/2013 19:37'!
initializeWithTimestamp: aTimestamp 
	
	timestamp := aTimestamp ! !

!Clock methodsFor: 'accesing' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 17:34'!
plusMinutes: minutes 

	self timeStamp: (timestamp plusSeconds: minutes * 60) ! !

!Clock methodsFor: 'accesing' stamp: 'EmilianoEzequielNicols 6/7/2013 20:12'!
timeStamp

	^timestamp ! !

!Clock methodsFor: 'accesing' stamp: 'EmilianoEzequielNicols 6/7/2013 20:16'!
timeStamp: aNewTimestamp 

	timestamp := aNewTimestamp ! !

Object subclass: #CreditCard
	instanceVariableNames: 'number owner expirationDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'creation' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 17:37'!
newWithNumber: aNumber andOwner: anOwner andExpirationDate: anExpirationDate
	^ self new initializeWithNumber: aNumber andOwner: anOwner andExpirationDate: anExpirationDate.! !

!CreditCard methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 17:39'!
expirationDate
	^ expirationDate! !

!CreditCard methodsFor: 'creation' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 18:45'!
initializeWithNumber: aNumber andOwner: anOwner andExpirationDate: anExpirationDate

	(aNumber trim size = 0) ifTrue: [ ^ Error signal: 'Credit card number cannot be empty.' ].
	(anOwner trim size = 0) ifTrue: [ ^ Error signal: 'Credit card owner cannot be empty.' ].
	(anOwner trim size > 30) ifTrue: [ ^ Error signal: 'Credit card owner cannot be greater than 30 characters long.' ].
	
	number := aNumber trim.
	owner := anOwner.
	expirationDate := anExpirationDate.! !

!CreditCard methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 19:51'!
isExpired: aDate
	^ expirationDate < aDate! !

!CreditCard methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 17:38'!
number
	^ number! !

!CreditCard methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/1/2013 17:39'!
owner
	^ owner! !

Object subclass: #PluggableMerchantProcessor
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!PluggableMerchantProcessor class methodsFor: 'as yet unclassified' stamp: 'EmilianoEzequielNicols 6/6/2013 20:15'!
newWith: aBlock 
	
	^self new initializeWith: aBlock! !

!PluggableMerchantProcessor methodsFor: 'operation' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 20:01'!
debit: anAmount fromCard: aCreditCard 
	
	result value! !

!PluggableMerchantProcessor methodsFor: 'initilization' stamp: 'EmilianoEzequielNicols 6/6/2013 20:27'!
initializeWith: aResult

	result := aResult! !

Object subclass: #Publisher
	instanceVariableNames: 'salesBook catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Publisher class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/8/2013 21:47'!
newWith: aCatalog
	
	
	^self new initializeWith: aCatalog! !

!Publisher methodsFor: 'adding' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 20:04'!
addSale: aTicket for: aClientId 

   	|clientSales|

	clientSales := self getSalesFor: aClientId.
	clientSales add: aTicket.
	salesBook at: aClientId put: clientSales.
	
		
	
	! !

!Publisher methodsFor: 'initializing' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 17:52'!
catalog

	^catalog ! !

!Publisher methodsFor: 'operation' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 20:44'!
getSalesFor: aClientId 
	
	^salesBook at: aClientId  ifAbsentPut: [OrderedCollection new ]! !

!Publisher methodsFor: 'adding' stamp: 'EmilianoEzequielNicols 6/9/2013 13:47'!
includes: aClientId 
	
	^salesBook includesKey: aClientId! !

!Publisher methodsFor: 'initializing' stamp: 'EmilianoMenendezEzequielNicols 6/8/2013 21:48'!
initializeWith: aCatalog

	salesBook  := Dictionary new.
	catalog := aCatalog! !

Object subclass: #SecurityGuard
	instanceVariableNames: 'userRegistry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!SecurityGuard class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 20:09'!
newWith: aRegistry

	^self new initializeWith: aRegistry! !

!SecurityGuard methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 20:10'!
initializeWith: aRegistry

	userRegistry:= aRegistry ! !

!SecurityGuard methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/5/2013 21:16'!
validate: aUser with: aPassword

	((userRegistry includesKey: aUser) and: [(userRegistry at: aUser ) = aPassword ]) ifTrue: [^ Random new nextInt: 10000000].
	^ Error signal: 'Invalid User or Password.'! !

Object subclass: #Session
	instanceVariableNames: 'creationTime lastAccessTime cart clock clientId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Session class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 18:49'!
newWithClientId: aClientId andCart: aCart andClock: aClock
	
	^self new initializeWithClientId: aClientId andCart: aCart andClock: aClock.! !

!Session methodsFor: 'expiration' stamp: 'EmilianoEzequielNicols 6/9/2013 17:41'!
KeepActive
	
	|newTimestamp|
	
	newTimestamp := (TimeStamp now).
	clock timeStamp: newTimestamp.
	! !

!Session methodsFor: 'accesing' stamp: 'EmilianoEzequielNicols 6/7/2013 00:14'!
cart
	
	^cart! !

!Session methodsFor: 'accesing' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 16:52'!
clientId
	
	^ clientId! !

!Session methodsFor: 'accesing' stamp: 'EmilianoEzequielNicols 6/8/2013 20:33'!
getClientId
	
	^clientId ! !

!Session methodsFor: 'expiration' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 18:56'!
hasExpired
	
	|secondsIn30Minutes|
	
	secondsIn30Minutes := 1800.
	
	^(clock timeStamp) >=  (lastAccessTime plusSeconds: secondsIn30Minutes )  
	! !

!Session methodsFor: 'initializing' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 18:53'!
initializeWithClientId: aClientId andCart: aCart andClock: aClock
	
	clientId := aClientId.
	cart := aCart.
	clock := aClock.
	lastAccessTime := clock timeStamp.! !

!Session methodsFor: 'initializing' stamp: 'EmilianoEzequielNicols 6/7/2013 21:51'!
initializeWithCreationTime: aTime andLastAccessTime: anotherTime andCart: aCart andTestingClock: aClock 
	
	creationTime := aTime.
	lastAccessTime := anotherTime.
	cart := aCart.
	clock := aClock! !

!Session methodsFor: 'expiration' stamp: 'EmilianoEzequielNicols 6/9/2013 14:10'!
isExpired
	
	|secondsIn30Minutes|
	
	secondsIn30Minutes := 1800.
	
	^(clock timeStamp) >  (lastAccessTime plusSeconds: secondsIn30Minutes )  
	! !

!Session methodsFor: 'expiration' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 18:21'!
keepActive
	lastAccessTime := clock timeStamp.! !

!Session methodsFor: 'accesing' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 19:11'!
lastAccessTime
	
	^ lastAccessTime
! !

!Session methodsFor: 'operating' stamp: 'EmilianoEzequielNicols 6/7/2013 23:34'!
setLastAccessTime: aTimeStamp 
	lastAccessTime := aTimeStamp ! !

Object subclass: #Ticket
	instanceVariableNames: 'items total transactionResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Ticket class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 20:20'!
newFrom: aCart withTotal: anAmount andTransactionResult: anObject
	^ Ticket new initializeWith: aCart andTotal: anAmount andTransactionResult: aResult! !

!Ticket methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 20:12'!
= anObject
	^ (anObject isKindOf: Ticket) and: [items = anObject items ] and: [ transactionResult = anObject transactionResult ] and: [ total = anObject items ]! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 21:41'!
addCartItems: aCart 
	
	|ticketItems|
	
	ticketItems := OrderedCollection new: aCart items size.
	
	aCart items do: [ :anItem | ticketItems add: (TicketItem newWith: anItem and: (aCart itemQuantity: anItem) and: (aCart itemPrice: anItem))  ].

	^ticketItems! !

!Ticket methodsFor: 'initializing' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 23:13'!
initializeWith: aCart andTotal: anAmount andTransactionResult: aResult
	
	
	items :=  self addCartItems: aCart.
	total := anAmount.
	transactionResult := aResult.! !

!Ticket methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 21:40'!
items
	
	^ items! !

!Ticket methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 6/1/2013 14:36'!
total
	^ total! !

!Ticket methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 23:13'!
transactionResult
	^ transactionResult! !

Object subclass: #TicketItem
	instanceVariableNames: 'quantity price name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TicketItem class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 21:07'!
newWith: anItem and: aQuantity and: aPrice 
	
	^self new initializeWith: anItem and: aQuantity and: aPrice ! !

!TicketItem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 20:13'!
= anObject
	^ (anObject isKindOf: TicketItem) and: [name = anObject itemName ] and: [ price = anObject price ] and: [ quantity = anObject quantity ]! !

!TicketItem methodsFor: 'initializinig' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:41'!
initializeWith: anItem and: aQuantity and: aUnitPrice

	name := anItem.
	quantity := aQuantity.
	price := aUnitPrice * aQuantity.

	 
	
	! !

!TicketItem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 22:44'!
itemName
	^ name! !

!TicketItem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 21:20'!
price
	^ price! !

!TicketItem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielNicolas 6/7/2013 21:20'!
quantity
	^ quantity! !

Object subclass: #TusLibrosInterface
	instanceVariableNames: 'securityGuard sessionsRegistry clock cashier publisher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosInterface class methodsFor: 'creation' stamp: 'EmilianoEzequielNicols 6/9/2013 00:59'!
newWithSecurityGuard: aSecurityGuard andClock: aClock andCashier: aCashier andPublisher: aPublisher
	
	
	^self new initializeWithSecurityGuard: aSecurityGuard andClock: aClock andCashier: aCashier andPublisher: aPublisher ! !

!TusLibrosInterface methodsFor: 'operation' stamp: 'EmilianoEzequielNicols 6/9/2013 16:56'!
addToCart: aCartId aBookISBN: anISBN withQuantity:aQuantity

	|cart session|
		
	session := self getSessionWithId: aCartId.

	self checkSessionHasNotExpired: session.
	 
	cart := self getCartWithId: aCartId.
	cart add: anISBN withQuantity: aQuantity.
	
	session keepActive.
! !

!TusLibrosInterface methodsFor: 'operation' stamp: 'EmilianoEzequielNicols 6/9/2013 21:24'!
checkOut: cartId payingWith: aCreditCard 

	| cart newTicket clientId session |

       "Esto tambien chequea que exista la cartId"
       session := self getSessionWithId: cartId.

	(session isExpired) ifTrue: [ ^Error signal: 'Session has expired' ].

       "Esto verifica que la sesion no haya expirado, ya esta subido al repo".
	self checkSessionHasNotExpired: session.

	cart := self getCartWithId: cartId.
	
	newTicket := cashier checkOut: cart payingWith: aCreditCard.
	
	clientId := session getClientId.
		
	publisher addSale: newTicket for: clientId.! !

!TusLibrosInterface methodsFor: 'support' stamp: 'EmilianoEzequielNicols 6/9/2013 17:59'!
checkSessionHasNotExpired: aSession
	(aSession hasExpired) ifTrue: [ ^Error signal: 'Session has expired' ].
	^false! !

!TusLibrosInterface methodsFor: 'accesing' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 17:41'!
clock
	^ clock! !

!TusLibrosInterface methodsFor: 'operation' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 23:53'!
createCartFor: aUsername usingPassword: aPassword  
	
	| cartId cart newSession |
	
	cartId  := securityGuard validate: aUsername  with: aPassword.
	cart := Cart newCartWithCatalog: (publisher catalog). 
	
	newSession := Session newWithClientId: aUsername andCart: cart  andClock: self clock.
	publisher getSalesFor: newSession clientId.
	sessionsRegistry at: cartId put: newSession.
	
	^cartId ! !

!TusLibrosInterface methodsFor: 'accesing' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 18:51'!
getCartWithId: aCartId 
	 | session |
	
	 session := self getSessionWithId: aCartId.
	 
	 ^ session cart.! !

!TusLibrosInterface methodsFor: 'accesing' stamp: 'EmilianoEzequielNicols 6/9/2013 21:46'!
getPublisher
	
	^publisher ! !

!TusLibrosInterface methodsFor: 'accesing' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 17:25'!
getSessionWithId: aCartId 
	((sessionsRegistry includesKey: aCartId)not) ifTrue: [^Error signal: 'CartId Not Found'].
	^(sessionsRegistry at: aCartId )! !

!TusLibrosInterface methodsFor: 'initializing' stamp: 'EmilianoMenendezEzequielNicols 6/9/2013 22:28'!
initializeWithSecurityGuard: aSecurityGuard andClock: aClock andCashier: aCashier andPublisher: aPublisher
	
	securityGuard := aSecurityGuard. 
	sessionsRegistry  := Dictionary new.
	clock := aClock.
	cashier := aCashier.
	publisher := aPublisher! !

!TusLibrosInterface methodsFor: 'operation' stamp: 'EmilianoMenendezEzequielNicolas 6/8/2013 17:24'!
listCart: aCartId 

	|cart session |
	
	session := self getSessionWithId: aCartId.
	
	self checkSessionHasNotExpired: session.
	
	cart := self getCartWithId: aCartId.
	
	session keepActive.
	
	^cart items
! !

!TusLibrosInterface methodsFor: 'operation' stamp: 'EmilianoEzequielNicols 6/9/2013 21:34'!
listPurchasesOf: aClientId 
	
	((publisher includes: aClientId) not) ifTrue: [ ^Error signal: 'Invalid User' ].
	^publisher getSalesFor: aClientId.
! !
